/**
 * @author lany44
 * @date 2018/7/16-下午2:59
 * @file getValue
 */

export default (value = {}, field = '', options = {needSplit: true}) => {
    if (typeof value !== 'object') {
        return value;
    }

    if (!options || options.needSplit === false) return value[field];

    const fields = field.split('.');
    return fields.reduce((preVal, currVal) => {
        if (!preVal) return null;
        return preVal[currVal];
    }, value);
};
